#Written by Andrew Avila, 2011

from pdb_push import *
from pdb_centermass import *
import datetime
import subprocess

autodock_utils = "/usr/lib/python2.6/dist-packages/AutoDockTools/Utilities24/"

def DBCheckBatch(id):
    return DBQueryDataFunc('SELECT STATUS FROM BATCH WHERE ID = %s' % id, [], lambda x, y: y)[0][0]

def DBUpdateBatch(id, status):
    return DBQueryDataFunc('UPDATE BATCH SET BATCH.STATUS = \'%s\' WHERE ID = \'%s\'' % (status, id), [], lambda x, y: y)

def DBCheckINITBatch():
    return DBQueryDataFunc('SELECT ID, CHAINS_ID, LIGANDS_ID FROM BATCH WHERE STATUS = \'INIT\' LIMIT 8', [], lambda x, y: y)

def DBGetChain(chains_id):
    return DBQueryDataFunc('SELECT DUMP FROM CHAINS_FILE WHERE CHAINS_ID = %s' % chains_id, [], lambda x, y: y)[0][0]

def DBGetLigand(ligands_id):
    return DBQueryDataFunc('SELECT DUMP FROM LIGANDS_FILE WHERE LIGANDS_ID = %s' % ligands_id, [], lambda x, y: y)[0][0]

def UploadResults(chains_id, ligands_id, data, dump):
    results_file_id = DBInsertFunc('RESULTS_FILE', {'DUMP' : dump})

    for i in data:
        if i != []:
            DBInsertFunc('RESULTS', {'RESULTS_FILE_ID' : results_file_id, 'CHAINS_ID' : chains_id, 'LIGANDS_ID' : ligands_id, 'FILE_INDEX' : i[0], 'ENERGY' : i[1], 'RMSD_LB' : i[2], 'RMSD_UB' : i[3]})

def DoBatch(batch_id, chains_id, ligands_id):
    chain = DBGetChain(chains_id)
    ligand = DBGetLigand(ligands_id)

    chain_name = "%s_%s_%s_c" % (batch_id, chains_id, ligands_id)
    ligand_name = "%s_%s_%s_l" % (batch_id, chains_id, ligands_id)

    g = open(chain_name + '.pdb','w')
    g.write(chain)
    g.close()

    g = open(ligand_name + '.pdb','w')
    g.write(ligand)
    g.close()

    subprocess.call(["python", autodock_utils + "prepare_receptor4.py", "-r", chain_name + '.pdb'])
    subprocess.call(["python", autodock_utils + "prepare_ligand4.py", "-l", ligand_name + '.pdb'])

    center =  pdbCentermass(chain.split('\n'))[0]

    vinaout = subprocess.Popen(["vina", "--receptor", chain_name + '.pdbqt', "--ligand", ligand_name + '.pdbqt', "--center_x", center[0].strip(), "--center_y", center[1].strip(), "--center_z", center[2].strip(), "--size_x", "30.0", "--size_y", "30.0", "--size_z", "30.0"], stdout=subprocess.PIPE).communicate()[0]

    foundres = False
    results = []
    for i in vinaout.split('\n'):
        if foundres == True and i != "Writing output ... done.":
            results.append(i.split())
        if i == "-----+------------+----------+----------":
            foundres = True

    g = open(ligand_name + '_out.pdbqt', 'r')
    resultsfile = g.read()
    g.close

    UploadResults(chains_id, ligands_id, results, resultsfile)

    subprocess.call(["rm", chain_name + '.pdb', chain_name + '.pdbqt', ligand_name + '.pdb', ligand_name + '.pdbqt', ligand_name + '_out.pdbqt'])
